<?php

  if (empty($xmlPathFromHere)) {
    $xmlPathFromHere = ""; // path to PHP XML data from within current directory (*requires trailing slash if not empty*)
  }

  // create an XSLT processor 
  $xsltproc = xslt_create(); 

  $cwd = getcwd();
  $xsltparams = null;

  $xmlFile = "file://".$cwd."/".$xmlPathFromHere."../photos.xml";
  $xslFile = "file://".$cwd."/".$xmlPathFromHere."data/photo-template.xsl";

  $xhtml = xslt_process($xsltproc, $xmlFile, $xslFile, null, array(), array());
  // Detect errors 
  if (!$xhtml) {
    print "There was an XSLT error. Try validating your XML formatting (open it in a browser and look for error messages.)\n";
    die('XSLT processing error: '.xslt_error($xsltproc)); 
  }

  // Destroy the XSLT processor 
  xslt_free($xsltproc); 

  print $xhtml;

?>